"use strict";

var WebSocket = require('websocket').client;
var hex_md5 = require('md5');

var serverUrl;
serverUrl = "ws://192.168.5.244/rpc";
var username = "bob"
var password = "hello"

var client = new WebSocket();

client.on('connectFailed', function(error) {
//    console.log('Connect Error: ' + error.toString());
});

client.on('connect', function(connection) {
//    console.log('WebSocket Client Connected');
    connection.on('error', function(error) {
//        console.log("Connection Error: " + error.toString());
    });
    connection.on('close', function() {
//        console.log('echo-protocol Connection Closed');
    });
    connection.on('message', function(message) {
        if (message.type == 'utf8') {
//            console.log("Received: '" + message.utf8Data + "'");
            var msg = JSON.parse(message.utf8Data);
            if(msg.hasOwnProperty('error')){
            	var error = msg.error;
            	var hint = JSON.parse(error.message);
            	var method;
            	if(error.code === 401){
                    switch(msg.id){
                    case 123:
                        method = "FS.List";
                        break;
                    }
                    var respmsg = {
                        id: msg.id,
                        method: method,
                        auth: dodigest(hint, username, password)
                    }
// 		    console.log("Response: " + JSON.stringify(respmsg));
                    connection.sendUTF(JSON.stringify(respmsg));
            	}
            } else if(msg.hasOwnProperty('result')){
                switch(msg.id){
                case 123:
                    process.stdout.write("Listing:\n\t" + JSON.stringify(msg.result) + "\n");
                    break;
                }
            }
        }
    });
    if (connection.connected) {
        // method needs to be recalled later on error response
        var msg = {
            id: 123,
            method: "FS.List",
        };
        connection.sendUTF(JSON.stringify(msg));
    }
});

client.connect(serverUrl, 'json');


function dodigest(hint, user, pass) {
    var realm = hint.realm;
    var nonce = hint.nonce;
    var nc = hint.nc;
    var cnonce = Math.floor(Math.random() * (2**64));
    var str1 = user + ":" + realm + ":" + pass;
    var ha1 = hex_md5(str1);
    var str2 = "dummy_method:dummy_uri";
    var ha2 = hex_md5(str2);
    var rstr = ha1 + ":" + nonce + ":" + nc + ":" + cnonce + ":auth:" + ha2;
    var response = hex_md5(rstr);
    var respmsg = {
        realm: realm,
        username: user,
        nonce: nonce,
        cnonce: cnonce,
        response: response
    };
    return respmsg;
}
