"use strict";

var WebSocket = require('websocket').client;

var serverUrl;
serverUrl = "ws://192.168.5.244/rpc";

var client = new WebSocket();

client.on('connectFailed', function(error) {
//    console.log('Connect Error: ' + error.toString());
});

client.on('connect', function(connection) {
//    console.log('WebSocket Client Connected');
    connection.on('error', function(error) {
//        console.log("Connection Error: " + error.toString());
    });
    connection.on('close', function() {
//        console.log('echo-protocol Connection Closed');
    });
    connection.on('message', function(message) {
        if (message.type === 'utf8') {
//            console.log("Received: '" + message.utf8Data + "'");
		var msg = JSON.parse(message.utf8Data);
		switch(msg.id){
		case 123:
			process.stdout.write("WiFi config is:\n\t" + JSON.stringify(msg.result) + "\n");
			break;
		case 456:
			process.stdout.write("System info:\n\t" + JSON.stringify(msg.result) + "\n");
			break;
		}
        }
    });
    function do1() {
        if (connection.connected) {
		var msg = {
			id: 123,
			method: "Config.Get",
			params: {key: "wifi.sta"}
		};
		connection.sendUTF(JSON.stringify(msg));
        }
    }
    function do0() {
        if (connection.connected) {
		var msg = {
			id: 456,
			method: "Sys.GetInfo"
		};
		connection.sendUTF(JSON.stringify(msg));
        }
    }
    do0();
    do1();
});

client.connect(serverUrl, 'json');

